Index: trunk/FACT++/configure
===================================================================
--- trunk/FACT++/configure	(revision 11615)
+++ trunk/FACT++/configure	(revision 11618)
@@ -751,4 +751,10 @@
 IS_FALSE_FALSE
 IS_FALSE_TRUE
+HAS_VIEWER_FALSE
+HAS_VIEWER_TRUE
+HAS_FITS_H_FALSE
+HAS_FITS_H_TRUE
+HAS_IZSTREAM_H_FALSE
+HAS_IZSTREAM_H_TRUE
 HAS_ZLIB_FALSE
 HAS_ZLIB_TRUE
@@ -4804,11 +4810,11 @@
   lt_cv_nm_interface="BSD nm"
   echo "int some_variable = 0;" > conftest.$ac_ext
-  (eval echo "\"\$as_me:4806: $ac_compile\"" >&5)
+  (eval echo "\"\$as_me:4812: $ac_compile\"" >&5)
   (eval "$ac_compile" 2>conftest.err)
   cat conftest.err >&5
-  (eval echo "\"\$as_me:4809: $NM \\\"conftest.$ac_objext\\\"\"" >&5)
+  (eval echo "\"\$as_me:4815: $NM \\\"conftest.$ac_objext\\\"\"" >&5)
   (eval "$NM \"conftest.$ac_objext\"" 2>conftest.err > conftest.out)
   cat conftest.err >&5
-  (eval echo "\"\$as_me:4812: output\"" >&5)
+  (eval echo "\"\$as_me:4818: output\"" >&5)
   cat conftest.out >&5
   if $GREP 'External.*some_variable' conftest.out > /dev/null; then
@@ -6015,5 +6021,5 @@
 *-*-irix6*)
   # Find out which ABI we are using.
-  echo '#line 6017 "configure"' > conftest.$ac_ext
+  echo '#line 6023 "configure"' > conftest.$ac_ext
   if { { eval echo "\"\$as_me\":${as_lineno-$LINENO}: \"$ac_compile\""; } >&5
   (eval $ac_compile) 2>&5
@@ -7676,9 +7682,9 @@
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:7678: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:7684: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>conftest.err)
    ac_status=$?
    cat conftest.err >&5
-   echo "$as_me:7682: \$? = $ac_status" >&5
+   echo "$as_me:7688: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s "$ac_outfile"; then
      # The compiler can only warn and ignore the option if not recognized
@@ -8015,9 +8021,9 @@
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:8017: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:8023: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>conftest.err)
    ac_status=$?
    cat conftest.err >&5
-   echo "$as_me:8021: \$? = $ac_status" >&5
+   echo "$as_me:8027: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s "$ac_outfile"; then
      # The compiler can only warn and ignore the option if not recognized
@@ -8120,9 +8126,9 @@
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:8122: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:8128: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>out/conftest.err)
    ac_status=$?
    cat out/conftest.err >&5
-   echo "$as_me:8126: \$? = $ac_status" >&5
+   echo "$as_me:8132: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s out/conftest2.$ac_objext
    then
@@ -8175,9 +8181,9 @@
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:8177: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:8183: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>out/conftest.err)
    ac_status=$?
    cat out/conftest.err >&5
-   echo "$as_me:8181: \$? = $ac_status" >&5
+   echo "$as_me:8187: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s out/conftest2.$ac_objext
    then
@@ -10559,5 +10565,5 @@
   lt_status=$lt_dlunknown
   cat > conftest.$ac_ext <<_LT_EOF
-#line 10561 "configure"
+#line 10567 "configure"
 #include "confdefs.h"
 
@@ -10655,5 +10661,5 @@
   lt_status=$lt_dlunknown
   cat > conftest.$ac_ext <<_LT_EOF
-#line 10657 "configure"
+#line 10663 "configure"
 #include "confdefs.h"
 
@@ -12611,9 +12617,9 @@
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:12613: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:12619: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>conftest.err)
    ac_status=$?
    cat conftest.err >&5
-   echo "$as_me:12617: \$? = $ac_status" >&5
+   echo "$as_me:12623: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s "$ac_outfile"; then
      # The compiler can only warn and ignore the option if not recognized
@@ -12710,9 +12716,9 @@
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:12712: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:12718: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>out/conftest.err)
    ac_status=$?
    cat out/conftest.err >&5
-   echo "$as_me:12716: \$? = $ac_status" >&5
+   echo "$as_me:12722: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s out/conftest2.$ac_objext
    then
@@ -12762,9 +12768,9 @@
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:12764: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:12770: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>out/conftest.err)
    ac_status=$?
    cat out/conftest.err >&5
-   echo "$as_me:12768: \$? = $ac_status" >&5
+   echo "$as_me:12774: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s out/conftest2.$ac_objext
    then
@@ -18339,6 +18345,46 @@
 
 
-#AC_CHECK_FILE(gui/RawEventsViewer(izstream.h, [action.if-yes], [action-if-no])
-#AC_CHECK_FILE(gui/RawEventsViewer(fits.h    , [action.if-yes], [action-if-no])
+{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for gui/RawEventsViewer/izstream.h" >&5
+$as_echo_n "checking for gui/RawEventsViewer/izstream.h... " >&6; }
+if test "${ac_cv_file_gui_RawEventsViewer_izstream_h+set}" = set; then :
+  $as_echo_n "(cached) " >&6
+else
+  test "$cross_compiling" = yes &&
+  as_fn_error $? "cannot check for file existence when cross compiling" "$LINENO" 5
+if test -r "gui/RawEventsViewer/izstream.h"; then
+  ac_cv_file_gui_RawEventsViewer_izstream_h=yes
+else
+  ac_cv_file_gui_RawEventsViewer_izstream_h=no
+fi
+fi
+{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_file_gui_RawEventsViewer_izstream_h" >&5
+$as_echo "$ac_cv_file_gui_RawEventsViewer_izstream_h" >&6; }
+if test "x$ac_cv_file_gui_RawEventsViewer_izstream_h" = x""yes; then :
+  HAVE_IZSTREAM_H=yes
+else
+  HAVE_IZSTREAM_H=no
+fi
+
+{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for gui/RawEventsViewer/fits.h" >&5
+$as_echo_n "checking for gui/RawEventsViewer/fits.h... " >&6; }
+if test "${ac_cv_file_gui_RawEventsViewer_fits_h+set}" = set; then :
+  $as_echo_n "(cached) " >&6
+else
+  test "$cross_compiling" = yes &&
+  as_fn_error $? "cannot check for file existence when cross compiling" "$LINENO" 5
+if test -r "gui/RawEventsViewer/fits.h"; then
+  ac_cv_file_gui_RawEventsViewer_fits_h=yes
+else
+  ac_cv_file_gui_RawEventsViewer_fits_h=no
+fi
+fi
+{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_file_gui_RawEventsViewer_fits_h" >&5
+$as_echo "$ac_cv_file_gui_RawEventsViewer_fits_h" >&6; }
+if test "x$ac_cv_file_gui_RawEventsViewer_fits_h" = x""yes; then :
+  HAVE_FITS_H=yes
+else
+  HAVE_FITS_H=no
+fi
+
 
 # Needed to compile FACT++
@@ -21814,5 +21860,5 @@
 
 		cat > conftest.$ac_ext <<EOF
-#line 21816 "configure"
+#line 21862 "configure"
 #include "confdefs.h"
 #include <qglobal.h>
@@ -22523,4 +22569,29 @@
 fi
 
+ if test "$HAVE_IZSTREAM_H" = yes; then
+  HAS_IZSTREAM_H_TRUE=
+  HAS_IZSTREAM_H_FALSE='#'
+else
+  HAS_IZSTREAM_H_TRUE='#'
+  HAS_IZSTREAM_H_FALSE=
+fi
+
+ if test "$HAVE_FITS_H" = yes; then
+  HAS_FITS_H_TRUE=
+  HAS_FITS_H_FALSE='#'
+else
+  HAS_FITS_H_TRUE='#'
+  HAS_FITS_H_FALSE=
+fi
+
+
+ if test "$HAVE_FITS_H" = yes; then
+  HAS_VIEWER_TRUE=
+  HAS_VIEWER_FALSE='#'
+else
+  HAS_VIEWER_TRUE='#'
+  HAS_VIEWER_FALSE=
+fi
+
 
  if test "x" = "y"; then
@@ -22549,8 +22620,18 @@
 
 fi
-if test "$HAVE_ZLIB" = yes; then
+
+if test "$HAVE_FITS_H" = yes; then
+
+   if test "$HAVE_IZSTREAM_H" = yes; then
+
+      if test "$HAVE_ZLIB" = yes; then
   $as_echo "#define HAVE_ZLIB 1" >>confdefs.h
 
 fi
+
+fi
+
+fi
+
 
 ##########################################################################
@@ -22866,4 +22947,16 @@
 if test -z "${HAS_ZLIB_TRUE}" && test -z "${HAS_ZLIB_FALSE}"; then
   as_fn_error $? "conditional \"HAS_ZLIB\" was never defined.
+Usually this means the macro was only invoked conditionally." "$LINENO" 5
+fi
+if test -z "${HAS_IZSTREAM_H_TRUE}" && test -z "${HAS_IZSTREAM_H_FALSE}"; then
+  as_fn_error $? "conditional \"HAS_IZSTREAM_H\" was never defined.
+Usually this means the macro was only invoked conditionally." "$LINENO" 5
+fi
+if test -z "${HAS_FITS_H_TRUE}" && test -z "${HAS_FITS_H_FALSE}"; then
+  as_fn_error $? "conditional \"HAS_FITS_H\" was never defined.
+Usually this means the macro was only invoked conditionally." "$LINENO" 5
+fi
+if test -z "${HAS_VIEWER_TRUE}" && test -z "${HAS_VIEWER_FALSE}"; then
+  as_fn_error $? "conditional \"HAS_VIEWER\" was never defined.
 Usually this means the macro was only invoked conditionally." "$LINENO" 5
 fi
@@ -25258,4 +25351,8 @@
 { $as_echo "$as_me:${as_lineno-$LINENO}:  zlib                   / 'zlib.h'          found: $HAVE_ZLIB" >&5
 $as_echo "$as_me:  zlib                   / 'zlib.h'          found: $HAVE_ZLIB" >&6;}
+{ $as_echo "$as_me:${as_lineno-$LINENO}:  gui/RawEventsViewer/izstream.h             found: $HAVE_IZSTREAM_H" >&5
+$as_echo "$as_me:  gui/RawEventsViewer/izstream.h             found: $HAVE_IZSTREAM_H" >&6;}
+{ $as_echo "$as_me:${as_lineno-$LINENO}:  gui/RawEventsViewer/fits.h                 found: $HAVE_FITS_H" >&5
+$as_echo "$as_me:  gui/RawEventsViewer/fits.h                 found: $HAVE_FITS_H" >&6;}
 { $as_echo "$as_me:${as_lineno-$LINENO}:  cfitsio                / 'fitsio.h'        found: $HAVE_CFITSIO" >&5
 $as_echo "$as_me:  cfitsio                / 'fitsio.h'        found: $HAVE_CFITSIO" >&6;}
@@ -25421,6 +25518,20 @@
   :
 else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING:  zlib not found. Support for reading zipped files disabled!" >&5
-$as_echo "$as_me: WARNING:  zlib not found. Support for reading zipped files disabled!" >&2;}
+  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING:  zlib not found. Support for reading zipped files viewer disabled!" >&5
+$as_echo "$as_me: WARNING:  zlib not found. Support for reading zipped files viewer disabled!" >&2;}
+
+fi
+if test "$HAVE_IZSTREAM_H" = yes; then
+  :
+else
+  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING:  Mars izstream.h not found in gui/RawEventsViwer. Support for reading zipped files in viewer disabled!" >&5
+$as_echo "$as_me: WARNING:  Mars izstream.h not found in gui/RawEventsViwer. Support for reading zipped files in viewer disabled!" >&2;}
+
+fi
+if test "$HAVE_FITS_H" = yes; then
+  :
+else
+  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING:  Mars fits.h not found in gui/RawEventsViwer. Support for viewer disabled!" >&5
+$as_echo "$as_me: WARNING:  Mars fits.h not found in gui/RawEventsViwer. Support for viewer disabled!" >&2;}
 
 fi
@@ -25452,6 +25563,6 @@
   :
 else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING:  Either QT4 or qt-root is missing: GUI disabled!" >&5
-$as_echo "$as_me: WARNING:  Either QT4 or qt-root is missing: GUI disabled!" >&2;}
+  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING:  Either QT4 or qt-root is missing: GUIs disabled!" >&5
+$as_echo "$as_me: WARNING:  Either QT4 or qt-root is missing: GUIs disabled!" >&2;}
 
 fi